<template>
  <q-select
    v-if="field.config.fieldType === 'dropdown'"
    v-model="record[field.config.field]"
    :stack-label="field.label"
    inverted-light
    color="white"
    :options="availableValues"
    :fitler="availableValues.length > 10"
    :multiple="field.config.isMultiple"
    :chips="field.config.isMultiple"
  />
  <q-input
    v-else-if="field.config.fieldType === 'autocomplete' && !field.config.isMultiple"
    v-model="record[field.config.field]"
    :stack-label="field.label"
    inverted-light
    color="white"
  >
  </q-input>
  <q-chips-input
    v-else-if="field.config.fieldType === 'autocomplete' && field.config.isMultiple"
    v-model="record[field.config.field]"
    :stack-label="field.label"
    inverted-light
    color="white"
  >
  </q-chips-input>
  <div v-else/>
</template>

<script>
  import endpointsMixin from '../../../mixins/endpointsMixin';

  export default {
    name: 'dropdownField',
    mixins: [endpointsMixin],
    data() {
      return {
        availableValues: [],
      };
    },
    created() {
      this.loadData();
    },
    methods: {
      loadData() {
        this.fetchData({ endpoint: `rest-sql/${ this.field.config.collection }/list` })
          .then(({ records }) => {
            this.availableValues = records.map((record) => ({
              value: record[this.field.config.keyField],
              label: String(record[this.field.config.labelField]),
            }));
          });
      },
    },
    props: {
      field: {
        type: Object,
      },
      record: {
        type: Object,
      },
    },
  };
</script>
